import { Module } from "@nestjs/common";

import { AppController } from "./app.controller";
import { ProducerService } from "@ocm-engine/nats";
import { ConfigModule } from "@nestjs/config";
import { cmConfig, cmSchema, natsConfig, natsSchema } from "@ocm-engine/config";
import Joi from "joi";

const validationSchema = Joi.object({
  nats: natsSchema,
  cm: cmSchema,
});

@Module({
  imports: [
    ConfigModule.forRoot({
      isGlobal: true,
      load: [natsConfig, cmConfig],
      validationSchema,
    }),
  ],
  controllers: [AppController],
  providers: [ProducerService],
})
export class AppModule {}
