import { Module } from "@nestjs/common";

import { AppController } from "./app.controller";
import Joi from "joi";
import { natsConfig, natsSchema, pmConfig, pmSchema } from "@ocm-engine/config";
import { ConfigModule } from "@nestjs/config";
import { ProducerService } from "@ocm-engine/nats";

const validationSchema = Joi.object({
  nats: natsSchema,
  pm: pmSchema,
});

@Module({
  imports: [
    ConfigModule.forRoot({
      isGlobal: true,
      load: [natsConfig, pmConfig],
      validationSchema,
    }),
  ],
  controllers: [AppController],
  providers: [ProducerService],
})
export class AppModule {}
