/**
 * This is not a production server yet!
 * This is only a minimal backend to get started.
 */

import { Logger } from "@nestjs/common";
import { NestFactory } from "@nestjs/core";

import { AppModule } from "./app/app.module";
import { ConfigService } from "@nestjs/config";
import { MicroserviceOptions, Transport } from "@nestjs/microservices";
import { IProofManagerConfig } from "@ocm-engine/config";

async function bootstrap() {
  const app = await NestFactory.create(AppModule);

  const configService = app.get(ConfigService);
  const pm = configService.get<IProofManagerConfig>("pm")!;

  app.enableShutdownHooks();

  const microservice = app.connectMicroservice<MicroserviceOptions>({
    transport: Transport.TCP,
    options: {
      host: pm.host,
      port: pm.port,
    },
  });

  await app.startAllMicroservices();

  app.enableShutdownHooks();

  Logger.log(`Application is running ${pm.host}:${pm.port}`);
}

bootstrap();
