import { ArrayMinSize, IsArray, IsNotEmpty, IsString } from "class-validator";

export class CreateSchemaResponseDto {
  @IsNotEmpty()
  @IsString()
  schemaId: string;

  @IsNotEmpty()
  @IsString()
  issuerId: string;

  @IsNotEmpty()
  @IsString()
  name: string;

  @IsNotEmpty()
  @IsString()
  version: string;

  @IsArray()
  @IsString({ each: true })
  @ArrayMinSize(1)
  attributes: string[];
}
