export type ConnectionEvent =
  | "connections.create"
  | "connections.accept"
  | "connections.list"
  | "connections.get";

export const CONNECTION_CREATE: ConnectionEvent = "connections.create";
export const CONNECTION_ACCEPT: ConnectionEvent = "connections.accept";
export const CONNECTION_LIST: ConnectionEvent = "connections.list";
export const CONNECTION_GET: ConnectionEvent = "connections.get";

export const CONNECTION_EVENTS: ConnectionEvent[] = [
  CONNECTION_CREATE,
  CONNECTION_ACCEPT,
  CONNECTION_LIST,
  CONNECTION_GET,
];

export type SchemaEvent = "schemas.create" | "schemas.get" | "schemas.list";
export const SCHEMA_CREATE: SchemaEvent = "schemas.create";
export const SCHEMA_GET: SchemaEvent = "schemas.get";
export const SCHEMA_LIST: SchemaEvent = "schemas.list";

export const SCHEMA_EVENTS: SchemaEvent[] = [
  SCHEMA_CREATE,
  SCHEMA_LIST,
  SCHEMA_GET,
];

export type CredentialEvent =
  | "credentials.definition.create"
  | "credentials.issue"
  | "credentials.list"
  | "credentials.offer.list"
  | "credentials.offer.accept";

export const CRED_DEF_CREATE = "credentials.definition.create";
export const CRED_ISSUE = "credentials.issue";
export const CRED_LIST = "credentials.list";
export const CRED_OFFER_LIST = "credentials.offer.list";
export const CRED_OFFER_ACCEPT = "credentials.offer.accept";

export const CRED_EVENTS: CredentialEvent[] = [
  CRED_DEF_CREATE,
  CRED_ISSUE,
  CRED_LIST,
  CRED_OFFER_LIST,
  CRED_OFFER_ACCEPT,
];

export type ProofEvent = "proofs.list" | "proofs.accept" | "proofs.issue";

export const PROOF_LIST = "proofs.list";
export const PROOF_ACCEPT = "proofs.accept";
export const PROOF_ISSUE = "proofs.issue";

export const PROOF_EVENTS: ProofEvent[] = [
  PROOF_ACCEPT,
  PROOF_LIST,
  PROOF_ISSUE,
];

export type BasicMessageEvent = "messages.make";
export const MESSAGE_MAKE = "messages.make";

export const DIDCOMM_EVENTS: BasicMessageEvent[] = [MESSAGE_MAKE];

export const ALL_EVENTS = [
  ...SCHEMA_EVENTS,
  ...CRED_EVENTS,
  ...PROOF_EVENTS,
  ...CONNECTION_EVENTS,
  ...DIDCOMM_EVENTS,
];
